Index: src/settings.cpp
===================================================================
--- src/settings.cpp	(revision 14572)
+++ src/settings.cpp	(working copy)
@@ -1458,7 +1458,16 @@
 	 SDTC_BOOL(gui.show_track_reservation,               S,  0, false,                        STR_CONFIG_PATCHES_SHOW_TRACK_RESERVATION,      RedrawScreen),
 	  SDTC_VAR(gui.default_signal_type,       SLE_UINT8, S, MS,     0,        0,        2, 1, STR_CONFIG_PATCHES_DEFAULT_SIGNAL_TYPE,         NULL),
 	  SDTC_VAR(gui.cycle_signal_types,        SLE_UINT8, S, MS,     0,        0,        2, 1, STR_CONFIG_PATCHES_CYCLE_SIGNAL_TYPES,          NULL),
-
+	SDTC_BOOL(gui.persistant_buildtools,                 S,  0, false,                        STR_CONFIG_PATCHES_PERSISTANT_BUILDTOOLS,       NULL),
+	SDTC_BOOL(gui.auto_screenshot,                      S,  0, false,                        STR_CONFIG_PATCHES_AUTO_GIANT_SCREEN,           NULL),
+	SDTC_VAR(gui.auto_screenshot_interval, SLE_UINT16, S,  0,    15,        1,     1000, 1, STR_CONFIG_PATCHES_AUTO_GIANT_SCREEN_INTERVAL,  NULL),
+	SDTC_VAR(gui.auto_screenshot_zoomlvl,   SLE_UINT8, S, MS,     0,        0,        3, 1, STR_CONFIG_PATCHES_AUTO_GIANT_SCREEN_ZOOMLVL,   NULL),
+	SDTC_BOOL(gui.auto_local_screen,                    S,  0, false,                        STR_CONFIG_PATCHES_AUTO_LOCAL_SCREEN,           NULL),
+	SDTC_VAR(gui.auto_local_screen_interval,SLE_UINT16,S,  0,    15,        1,     1000, 1, STR_CONFIG_PATCHES_AUTO_LOCAL_SCREEN_INTERVAL,  NULL),
+	SDTC_VAR(gui.auto_local_screen_zoomlvl, SLE_UINT8, S, MS,     0,        0,        3, 1, STR_CONFIG_PATCHES_AUTO_LOCAL_SCREEN_ZOOMLVL,   NULL),
+	SDTC_VAR(gui.auto_local_screen_size_x, SLE_UINT16, S,  0,   800,      100,     8000, 1, STR_NULL,                                       NULL),
+	SDTC_VAR(gui.auto_local_screen_size_y, SLE_UINT16, S,  0,   600,      100,     6000, 1, STR_NULL,                                       NULL),
+	
 	  SDTC_VAR(gui.console_backlog_timeout,  SLE_UINT16, S,  0,   100,       10,    65500, 0, STR_NULL,                                       NULL),
 	  SDTC_VAR(gui.console_backlog_length,   SLE_UINT16, S,  0,   100,       10,    65500, 0, STR_NULL,                                       NULL),
 #ifdef ENABLE_NETWORK
Index: src/bridge_gui.cpp
===================================================================
--- src/bridge_gui.cpp	(revision 14572)
+++ src/bridge_gui.cpp	(working copy)
@@ -22,6 +22,8 @@
 
 #include "table/strings.h"
 
+BridgeType _last_bridge_type = 0;
+
 /**
  * Carriage for the data we need if we want to build a bridge
  */
@@ -93,6 +95,7 @@
 
 	void BuildBridge(uint8 i)
 	{
+		_last_bridge_type = this->bridges->Get(i)->index;
 		DoCommandP(this->end_tile, this->start_tile, this->type | this->bridges->Get(i)->index,
 				CcBuildBridge, CMD_BUILD_BRIDGE | CMD_MSG(STR_5015_CAN_T_BUILD_BRIDGE_HERE));
 	}
@@ -286,6 +289,16 @@
 	 *     14..8 = road/rail types,
 	 *      7..0 = type of bridge */
 	uint32 type = (transport_type << 15) | (road_rail_type << 8);
+	
+	/* If Ctrl is being pressed, check wether the last bridge built is available 
+	 * If so, return this bridge type. Otherwise continue normally
+	 */
+	const uint bridge_len = GetTunnelBridgeLength(start, end);
+	if ( (_ctrl_pressed) && (CheckBridge_Stuff(_last_bridge_type, bridge_len))) {
+		DoCommandP(end, start, type | _last_bridge_type, CcBuildBridge,
+					CMD_BUILD_BRIDGE | CMD_MSG(STR_5015_CAN_T_BUILD_BRIDGE_HERE));
+		return;
+	}
 
 	/* only query bridge building possibility once, result is the same for all bridges!
 	 * returns CMD_ERROR on failure, and price on success */
@@ -298,9 +311,9 @@
 	} else {
 		/* check which bridges can be built
 		 * get absolute bridge length
-		 * length of the middle parts of the bridge */
-		const uint bridge_len = GetTunnelBridgeLength(start, end);
-		/* total length of bridge */
+		 * length of the middle parts of the bridge.
+		 *
+		 * total length of bridge */
 		const uint tot_bridgedata_len = CalcBridgeLenCostFactor(bridge_len + 2);
 
 		bl = new GUIBridgeList();
Index: src/console_gui.cpp
===================================================================
--- src/console_gui.cpp	(revision 14572)
+++ src/console_gui.cpp	(working copy)
@@ -153,7 +153,6 @@
 	IConsoleWindow(const WindowDesc *desc) : Window(desc)
 	{
 		_iconsole_mode = ICONSOLE_OPENED;
-		SetBit(_no_scroll, SCROLL_CON); // override cursor arrows; the gamefield will not scroll
 
 		this->height = _screen.height / 3;
 		this->width  = _screen.width;
@@ -162,7 +161,6 @@
 	~IConsoleWindow()
 	{
 		_iconsole_mode = ICONSOLE_CLOSED;
-		ClrBit(_no_scroll, SCROLL_CON);
 	}
 
 	virtual void OnPaint()
@@ -183,7 +181,7 @@
 
 		DoDrawString(_iconsole_cmdline.buf, 10 + delta, this->height - ICON_LINE_HEIGHT, CC_COMMAND);
 
-		if (_iconsole_cmdline.caret) {
+		if (_focused_window == this && _iconsole_cmdline.caret) {
 			DoDrawString("_", 10 + delta + _iconsole_cmdline.caretxoffs, this->height - ICON_LINE_HEIGHT, TC_WHITE);
 		}
 	}
Index: src/toolbar_gui.cpp
===================================================================
--- src/toolbar_gui.cpp	(revision 14572)
+++ src/toolbar_gui.cpp	(working copy)
@@ -1022,7 +1022,7 @@
 	}
 
 	virtual EventState OnKeyPress(uint16 key, uint16 keycode)
-	{
+	{ 
 		switch (keycode) {
 			case WKC_F1: case WKC_PAUSE: ToolbarPauseClick(this); break;
 			case WKC_F2: ShowGameOptions(); break;
@@ -1057,6 +1057,7 @@
 			case WKC_CTRL  | 'S': MenuClickSmallScreenshot(); break;
 			case WKC_CTRL  | 'G': MenuClickWorldScreenshot(); break;
 			case WKC_CTRL | WKC_ALT | 'C': if (!_networking) ShowCheatWindow(); break;
+			case WKC_CTRL | 'L': ShowSignList(); break;
 			case 'A': if (CanBuildVehicleInfrastructure(VEH_TRAIN)) ShowBuildRailToolbar(_last_built_railtype, 4); break; // Invoke Autorail
 			case 'L': ShowTerraformToolbar(); break;
 			case 'M': ShowSmallMap(); break;
Index: src/settings_gui.cpp
===================================================================
--- src/settings_gui.cpp	(revision 14572)
+++ src/settings_gui.cpp	(working copy)
@@ -614,6 +614,13 @@
 	"gui.default_rail_type",
 	"gui.always_build_infrastructure",
 	"gui.show_track_reservation",
+	"gui.persistant_buildtools",
+	"gui.auto_screenshot",
+	"gui.auto_screenshot_interval",
+	"gui.auto_screenshot_zoomlvl",
+	"gui.auto_local_screen",
+	"gui.auto_local_screen_interval",
+	"gui.auto_local_screen_zoomlvl",
 };
 
 static const char *_patches_construction[] = {
Index: src/genworld_gui.cpp
===================================================================
--- src/genworld_gui.cpp	(revision 14572)
+++ src/genworld_gui.cpp	(working copy)
@@ -251,13 +251,14 @@
 	char name[64];
 	glwp_modes mode;
 
-	GenerateLandscapeWindow(const WindowDesc *desc, WindowNumber number = 0) : QueryStringBaseWindow(11, desc, number)
+	GenerateLandscapeWindow(const WindowDesc *desc, WindowNumber number = 0) : QueryStringBaseWindow(11, desc, 0, 0, number)
 	{
 		this->LowerWidget(_settings_newgame.game_creation.landscape + GLAND_TEMPERATE);
 
 		/* snprintf() always outputs trailing '\0', so whole buffer can be used */
 		snprintf(this->edit_str_buf, this->edit_str_size, "%u", _settings_newgame.game_creation.generation_seed);
 		InitializeTextBuffer(&this->text, this->edit_str_buf, this->edit_str_size, 120);
+		this->SetFocusedWidget(GLAND_RANDOM_EDITBOX);
 		this->caption = STR_NULL;
 		this->afilter = CS_NUMERAL;
 
@@ -373,10 +374,6 @@
 				this->SetDirty();
 				break;
 
-			case GLAND_RANDOM_EDITBOX: // edit box for random seed
-				ShowOnScreenKeyboard(this, GLAND_RANDOM_EDITBOX, 0, 0);
-				break;
-
 			case GLAND_GENERATE_BUTTON: // Generate
 				_settings_game = _settings_newgame;
 
Index: src/misc_gui.cpp
===================================================================
--- src/misc_gui.cpp	(revision 14572)
+++ src/misc_gui.cpp	(working copy)
@@ -960,8 +960,28 @@
 	return false;
 }
 
+bool QueryString::HasEditBoxFocus(Window *w, int wid) const
+{
+	if (w->window_class == WC_OSK) {
+		if (_focused_window == w->parent &&
+				w->parent->focused_widget &&
+				w->parent->focused_widget->type == WWT_EDITBOX) {
+			return true;
+		}
+	}
+	if (w->IsWidgetGlobalyFocused(wid)) {
+		return true;
+	}
+
+	return false;
+}
+
 HandleEditBoxResult QueryString::HandleEditBoxKey(Window *w, int wid, uint16 key, uint16 keycode, Window::EventState &state)
 {
+	if (!QueryString::HasEditBoxFocus(w, wid)) {
+		return HEBR_NOT_FOCUSED;
+	}
+
 	state = Window::ES_HANDLED;
 
 	switch (keycode) {
@@ -999,7 +1019,7 @@
 
 void QueryString::HandleEditBox(Window *w, int wid)
 {
-	if (HandleCaret(&this->text)) w->InvalidateWidget(wid);
+	if (HasEditBoxFocus(w, wid) && HandleCaret(&this->text)) w->InvalidateWidget(wid);
 }
 
 void QueryString::DrawEditBox(Window *w, int wid)
@@ -1035,12 +1055,12 @@
 	if (tb->caretxoffs + delta < 0) delta = -tb->caretxoffs;
 
 	DoDrawString(tb->buf, delta, 0, TC_YELLOW);
-	if (tb->caret) DoDrawString("_", tb->caretxoffs + delta, 0, TC_WHITE);
+	if (HasEditBoxFocus(w, wid) && tb->caret) DoDrawString("_", tb->caretxoffs + delta, 0, TC_WHITE);
 
 	_cur_dpi = old_dpi;
 }
 
-int QueryStringBaseWindow::HandleEditBoxKey(int wid, uint16 key, uint16 keycode, EventState &state)
+HandleEditBoxResult QueryStringBaseWindow::HandleEditBoxKey(int wid, uint16 key, uint16 keycode, EventState &state)
 {
 	return this->QueryString::HandleEditBoxKey(this, wid, key, keycode, state);
 }
@@ -1055,6 +1075,11 @@
 	this->QueryString::DrawEditBox(this, wid);
 }
 
+void QueryStringBaseWindow::OnOpenOSKWindow(int wid)
+{
+	ShowOnScreenKeyboard(this, wid, 0, 0);
+}
+
 enum QueryStringWidgets {
 	QUERY_STR_WIDGET_TEXT = 3,
 	QUERY_STR_WIDGET_DEFAULT,
@@ -1065,10 +1090,10 @@
 
 struct QueryStringWindow : public QueryStringBaseWindow
 {
-	QueryStringWindow(uint16 size, const WindowDesc *desc, Window *parent) : QueryStringBaseWindow(size, desc)
+	QueryStringWindow(uint16 size, const WindowDesc *desc, Window *parent) : QueryStringBaseWindow(size, desc, QUERY_STR_WIDGET_CANCEL, QUERY_STR_WIDGET_OK)
 	{
 		this->parent = parent;
-		SetBit(_no_scroll, SCROLL_EDIT);
+		this->SetFocusedWidget(QUERY_STR_WIDGET_TEXT);
 
 		this->FindWindowPlacementAndResize(desc);
 	}
@@ -1098,10 +1123,6 @@
 	virtual void OnClick(Point pt, int widget)
 	{
 		switch (widget) {
-			case QUERY_STR_WIDGET_TEXT:
-				ShowOnScreenKeyboard(this, QUERY_STR_WIDGET_TEXT, QUERY_STR_WIDGET_CANCEL, QUERY_STR_WIDGET_OK);
-				break;
-
 			case QUERY_STR_WIDGET_DEFAULT:
 				this->text.buf[0] = '\0';
 				/* Fallthrough */
@@ -1131,10 +1152,16 @@
 			case HEBR_CONFIRM: this->OnOk();
 			/* FALL THROUGH */
 			case HEBR_CANCEL: delete this; break; // close window, abandon changes
+			case HEBR_NOT_FOCUSED: break;
 		}
 		return state;
 	}
 
+	virtual void OnOpenOSKWindow(int wid)
+	{
+		ShowOnScreenKeyboard(this, wid, QUERY_STR_WIDGET_CANCEL, QUERY_STR_WIDGET_OK);
+	}
+
 	~QueryStringWindow()
 	{
 		if (!this->handled && this->parent != NULL) {
@@ -1142,7 +1169,6 @@
 			this->parent = NULL; // so parent doesn't try to delete us again
 			parent->OnQueryTextFinished(NULL);
 		}
-		ClrBit(_no_scroll, SCROLL_EDIT);
 	}
 };
 
@@ -1177,7 +1203,6 @@
 void ShowQueryString(StringID str, StringID caption, uint maxsize, uint maxwidth, Window *parent, CharSetFilter afilter, QueryStringFlags flags)
 {
 	DeleteWindowById(WC_QUERY_STRING, 0);
-	DeleteWindowById(WC_SAVELOAD, 0);
 
 	QueryStringWindow *w = new QueryStringWindow(maxsize, &_query_string_desc, parent);
 
@@ -1432,7 +1457,7 @@
 		SanitizeFilename(this->edit_str_buf);
 	}
 
-	SaveLoadWindow(const WindowDesc *desc, SaveLoadDialogMode mode) : QueryStringBaseWindow(64, desc)
+	SaveLoadWindow(const WindowDesc *desc, SaveLoadDialogMode mode) : QueryStringBaseWindow(64, desc, 0, 0)
 	{
 		static const StringID saveload_captions[] = {
 			STR_4001_LOAD_GAME,
@@ -1443,7 +1468,6 @@
 		};
 
 		SetObjectToPlace(SPR_CURSOR_ZZZ, PAL_NONE, VHM_NONE, WC_MAIN_WINDOW, 0);
-		SetBit(_no_scroll, SCROLL_SAVE);
 
 		/* Use an array to define what will be the current file type being handled
 		 * by current file mode */
@@ -1491,6 +1515,11 @@
 				strecpy(o_dir.name, _personal_dir, lastof(o_dir.name));
 		}
 
+		/* Focus the edit box by default in the save windows */
+		if (_saveload_mode == SLD_SAVE_GAME || _saveload_mode == SLD_SAVE_SCENARIO) {
+			this->SetFocusedWidget(10);
+		}
+
 		this->vscroll.cap = 10;
 		this->resize.step_width = 2;
 		this->resize.step_height = 10;
@@ -1505,7 +1534,6 @@
 			if (_pause_game >= 0) DoCommandP(0, 0, 0, NULL, CMD_PAUSE);
 		}
 		FiosFreeSavegameList();
-		ClrBit(_no_scroll, SCROLL_SAVE);
 	}
 
 	virtual void OnPaint()
@@ -1599,10 +1627,6 @@
 				break;
 			}
 
-			case 10: // edit box
-				ShowOnScreenKeyboard(this, widget, 0, 0);
-				break;
-
 			case 11: case 12: // Delete, Save game
 				break;
 		}
@@ -1703,7 +1727,6 @@
 
 void ShowSaveLoadDialog(SaveLoadDialogMode mode)
 {
-	DeleteWindowById(WC_QUERY_STRING, 0);
 	DeleteWindowById(WC_SAVELOAD, 0);
 
 	const WindowDesc *sld;
Index: src/smallmap_gui.cpp
===================================================================
--- src/smallmap_gui.cpp	(revision 14572)
+++ src/smallmap_gui.cpp	(working copy)
@@ -1214,7 +1214,7 @@
 	_extra_view_port_widgets,
 };
 
-void ShowExtraViewPortWindow(TileIndex tile)
+int ShowExtraViewPortWindow(TileIndex tile)
 {
 	int i = 0;
 
@@ -1222,6 +1222,8 @@
 	while (FindWindowById(WC_EXTRA_VIEW_PORT, i) != NULL) i++;
 
 	new ExtraViewportWindow(&_extra_view_port_desc, i, tile);
+
+	return i;
 }
 
 bool ScrollMainWindowTo(int x, int y, bool instant)
Index: src/date.cpp
===================================================================
--- src/date.cpp	(revision 14572)
+++ src/date.cpp	(working copy)
@@ -15,6 +15,9 @@
 #include "vehicle_base.h"
 #include "debug.h"
 #include "rail_gui.h"
+#include "screenshot.h"
+#include "transparency.h"
+#include "signs_base.h"
 #ifdef DEBUG_DUMP_COMMANDS
 #include "saveload.h"
 #endif
@@ -234,6 +237,33 @@
 	if (_game_mode != GM_MENU) {
 		InvalidateWindowWidget(WC_STATUS_BAR, 0, 0);
 		EnginesDailyLoop();
+		if (_settings_client.gui.auto_local_screen && (_date % _settings_client.gui.auto_local_screen_interval == 0)) {
+			/* save the current transparency setting */
+			uint8 transparency_backup = _transparency_opt;
+			/* disable transparency for all unlocked transparency settings */
+			_transparency_opt &= _transparency_lock;
+			/* iterate through signs and take local screenshots if appropriate */
+			const Sign *si;
+			FOR_ALL_SIGNS(si) {
+				if (si->name != NULL && *si->name == '#') {
+					SetScreenshotType(SC_TIMELAPSE_LOCAL);
+					MakeScreenshot(si);
+				}
+			}
+			/* reset transparency to the former state */
+			_transparency_opt = transparency_backup;
+		}
+		if (_settings_client.gui.auto_screenshot && (_date % _settings_client.gui.auto_screenshot_interval == 0)) {
+			/* save the current transparency setting */
+			uint8 transparency_backup = _transparency_opt;
+			/* disable transparency for all unlocked transparency settings */
+			_transparency_opt &= _transparency_lock;
+			/* take a giant screenshot */
+			SetScreenshotType(SC_TIMELAPSE);
+			MakeScreenshot();
+			/* reset transparency to the former state */
+			_transparency_opt = transparency_backup;
+		}
 	}
 
 	/* check if we entered a new month? */
Index: src/airport_gui.cpp
===================================================================
--- src/airport_gui.cpp	(revision 14572)
+++ src/airport_gui.cpp	(working copy)
@@ -34,7 +34,7 @@
 {
 	if (success) {
 		SndPlayTileFx(SND_1F_SPLAT, tile);
-		ResetObjectToPlace();
+		if (! _settings_client.gui.persistant_buildtools) ResetObjectToPlace();
 	}
 }
 
